package auxdata;

import java.net.InetAddress;
import java.net.NetworkInterface;
import java.net.SocketException;
import java.net.UnknownHostException;
import java.util.Enumeration;

public class ConInfo {

	public static final byte[] SERVER1 = {-64,-88,1,-110};  // Hardcoded: 192.168.15.112 // my own
	public static final byte[] SERVER2 = {-64,-88,1,-127};	 // Hardcoded: 192.168.15.68
	public static final byte[] SERVER3 = {-64,-88,1,124};  // Hardcoded: 192.168.12.186
	public static final byte[][] SERVERS = {SERVER1, SERVER2, SERVER3};

	// MULTICAST SETUP
	public static final String MULTICASTGROUP = "225.1.1.1";
	public static final int MULTICASTPORT = 2500;
	public static final int MULTICASTTIMEOUT = 1500;

	// PORT SETUP 
	
	public static final int TCPDOWNLOADLISTENPORT = 2410;
	
	public static final int TCPLISTENPORT = 2510;
	public static final int TCPRECEIVEPORT = 2511;

	public static final int UDPLISTENPORT = 2520;
	public static final int UDPRECEIVEPORT = 2521;

	// PROTOCOL MESSAGES

	public static final String ACK = "ack";
	public static final String NAK = "nack";

	// client
	public static final String CLIENTRQUPLOAD = "crqu";
	public static final String RQFILEDOWNLOAD = "rqfd";

	// server
	public static final String SERVERRQFILEUPLOAD = "srqfu";
	public static final String SERVERRQFILEUPLOADOK = "srqfuok";
	public static final String FILESIZERECEIVEDOK = "fsrok";


	// TIMEOUTS
	public static final int UDPANSWERTIMEOUT = 1500;

	
	public static final int UDPPACKETSIZE = 1024;
	public static final int UDPPACKETHEADERLENGTH = 4;
	public static final int UDPPACKETDATASIZE = UDPPACKETSIZE - UDPPACKETHEADERLENGTH;
	public static final Object CLIENTRQFILEDOWNLOAD = "crqfd";

		

	public static InetAddress getOwnIp () {

		InetAddress result = null;

		try {
			Enumeration<NetworkInterface> e = NetworkInterface.getNetworkInterfaces();

			while(e.hasMoreElements()) {
				NetworkInterface ni =  e.nextElement();
				Enumeration<InetAddress> ias = ni.getInetAddresses();
				while (ias.hasMoreElements()) {
					InetAddress ia = ias.nextElement();
					if(!ia.isLoopbackAddress()) {
						result = ia; 
					}

				}
			}

		} catch (SocketException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

		return result;

	}

	public static InetAddress[] getTheTwoOtherServersIpAdresses() {
		InetAddress own = getOwnIp();
		InetAddress[] ias = new InetAddress[4];
		int j = 0;

		for (int i = 0; i < 3; i++) {
			try {
				if (!own.equals(InetAddress.getByAddress(SERVERS[i]))) {
					ias[j++] = InetAddress.getByAddress(SERVERS[i]);
				}
			} catch (UnknownHostException e) {
				System.err.println("Failed assigning ip address in getTheTwoOtherServersIpAdresses()");
			}
		}

		return ias;
	}

}
