package server.data;

import auxdata.ConInfo;

public class UtilMethods {
	
	public static byte[] intToBytes (int i) {
		byte[] result = new byte[4];
		
		result[0] = (byte)(i >> 24);
		result[1] = (byte)((i << 8) >> 24);
		result[2] = (byte)((i << 16) >> 24);
		result[3] = (byte)((i << 24) >> 24);
		
		return result;
	}
	
	public static int bytesToInt (byte[] b, int offset) {
		int result = 0;
		
        for (int i = 0; i < 4; i++) {
            int shift = (4 - 1 - i) * 8;
            result += (b[i + offset] & 0x000000FF) << shift;
        }
		
		return result;
	}
	
	public static byte booleanToByte (boolean b) {		
		if (b) {
			return 1;
		} else {
			return 0;
		}
		
	}
	
	public static boolean byteToBoolean (byte b) {
		if (b > 0) {
			return true;
		} else {
			return false;
		}
	}
	
	public static int getBlocksNeeded (int length) {
		
		int dataSize = ConInfo.UDPPACKETSIZE - ConInfo.UDPPACKETHEADERLENGTH;
		
		if (length % dataSize == 0) {
			return length / dataSize;
		} else {
			return (length / dataSize) + 1;
		}
		
	}
	
	/**
	 * @param a
	 * @param offsetA
	 * @param b
	 * @param offsetB
	 * @param numberOfBytes
	 * 
	 * copies numberOfBytes bytes from a to b.
	 * 
	 */
	public static void copyArray (byte[] a, int offsetA, byte[] b, int offsetB, int numberOfBytes) {
		
		for (int i = 0; i < numberOfBytes; i++) {
			b[i + offsetB] = a[i + offsetA];
		}
		
	}

}
