package server.threads;

import java.io.IOException;
import java.net.ServerSocket;
import java.util.Vector;

import server.data.FileElement;
import auxdata.ConInfo;

public class TCPUploadListenerThread extends Thread {

	private Vector<FileElement> fileStore = null;
	
	public TCPUploadListenerThread(Vector<FileElement> fileStore) {
		super("UploadListenerThread");
		this.fileStore = fileStore;
		System.out.println("fileStore size: " + fileStore.size());
	}

	public void run() {
		
		ServerSocket ss = null;
		boolean listening = true;

		try {
			//>>
			
			ss = new ServerSocket(ConInfo.TCPLISTENPORT);
			
			while (listening)
				new TCPUploadHandlerThread(ss.accept(), fileStore).start();
			
			//<<			
		} catch (IOException e) {
			System.err.println("Could not listen on port: " + ConInfo.TCPLISTENPORT + ".");
			e.printStackTrace();
			System.exit(-1);
		}		

		try {
			//<<
			
			ss.close();
			
			//>>			
		} catch (IOException e) {
			System.err.println("I/O error occured on closing connection on" + ConInfo.TCPLISTENPORT + ".");
			e.printStackTrace();
			System.exit(-1);
		}
	}
}
