package server.threads;

import java.io.IOException;
import java.net.DatagramPacket;
import java.net.DatagramSocket;
import java.util.Vector;

import server.data.FileElement;
import auxdata.ConInfo;

public class UDPUploadListenerThread extends Thread {

	private Vector<FileElement> fileStore;

	public UDPUploadListenerThread(Vector<FileElement> fileStore) {
		this.fileStore = fileStore;
	}

	public void run () {
		
		DatagramSocket ds;
		DatagramPacket receivePacket;
		
		Boolean running = true;

		try {
			
			ds = new DatagramSocket(ConInfo.UDPLISTENPORT);

			while (running) {
				byte[] protocolBuffer = new byte[16];
				receivePacket = new DatagramPacket(protocolBuffer, protocolBuffer.length);
				ds.receive(receivePacket);

				String data = new String(receivePacket.getData(), 0, receivePacket.getLength());
				
				if (data.equals(ConInfo.SERVERRQFILEUPLOAD)) {
					
					UDPUploadHandlerThread uuht = new UDPUploadHandlerThread(receivePacket.getAddress(), receivePacket.getPort());
					uuht.start();
					
				} else { // Unrecognised request, resend data please
					
					DatagramPacket returnPacket = new DatagramPacket(
							ConInfo.NAK.getBytes(), ConInfo.NAK.length(),
							receivePacket.getAddress(), receivePacket.getPort());
					ds.send(returnPacket);
					
				}
			}
			ds.close();

		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}

}
