package test;

import java.awt.Dimension;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.io.IOException;
import java.net.DatagramPacket;
import java.net.DatagramSocket;
import java.net.InetAddress;
import java.net.SocketException;
import java.net.UnknownHostException;

import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.SwingUtilities;

import auxdata.ConInfo;

public class MulticastPacketTester extends JFrame {

	private static final long serialVersionUID = 1L;

	private JPanel jContentPane = null;

	private JButton jButton = null;

	/**
	 * This method initializes jButton	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getJButton() {
		if (jButton == null) {
			jButton = new JButton();
			jButton.setText("Send UDP packet");
			jButton.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					try {
						DatagramSocket clientSocket = new DatagramSocket();
						InetAddress group = InetAddress.getByName(ConInfo.MULTICASTGROUP);
												
						String msg = new String(ConInfo.CLIENTRQUPLOAD);
						
						DatagramPacket sendPacket = new DatagramPacket(msg.getBytes(), msg.getBytes().length, group, ConInfo.MULTICASTPORT);
						clientSocket.send(sendPacket);
						
						byte[] rcvbuf = new byte[8];
						DatagramPacket packet = new DatagramPacket(rcvbuf, rcvbuf.length);
						System.out.println("sent packet");
						clientSocket.receive(packet); // This method blocks until a datagram is received.
						System.out.println("received packet");
						
						String data = new String(packet.getData(), 0, packet.getLength());
						
						if (data.equals(ConInfo.ACK)) {
							System.out.println("Ack received from host: " + packet.getAddress().getHostAddress());							
						}
						
					} catch (SocketException e1) {
						// TODO Auto-generated catch block
						e1.printStackTrace();
					} catch (UnknownHostException e2) {
						// TODO Auto-generated catch block
						e2.printStackTrace();
					} catch (IOException e3) {
						// TODO Auto-generated catch block
						e3.printStackTrace();
					}
				}
			});
		}
		return jButton;
	}

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		// TODO Auto-generated method stub
		SwingUtilities.invokeLater(new Runnable() {
			public void run() {
				MulticastPacketTester thisClass = new MulticastPacketTester();
				thisClass.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
				thisClass.setVisible(true);
			}
		});
	}

	/**
	 * This is the default constructor
	 */
	public MulticastPacketTester() {
		super();
		initialize();
	}

	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {
		this.setSize(300, 201);
		this.setPreferredSize(new Dimension(300,200));
		this.setContentPane(getJContentPane());
		this.setTitle("JFrame");
		this.pack();
	}

	/**
	 * This method initializes jContentPane
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJContentPane() {
		if (jContentPane == null) {
			GridBagConstraints gridBagConstraints = new GridBagConstraints();
			gridBagConstraints.gridx = 0;
			gridBagConstraints.gridy = 0;
			jContentPane = new JPanel();
			jContentPane.setLayout(new GridBagLayout());
			jContentPane.add(getJButton(), gridBagConstraints);
		}
		return jContentPane;
	}

}
